﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.CommonBot.Logic;
using Buddy.Swtor;
using JoesCombat.Dynamics;
using System.Diagnostics;

namespace JoesCombat.Routines
{
    public class AllCombatOOC
    {
        // *** ALL THIS SHIT HAS BEEN OVERRIDDEN IN JOESCOMBAT.CS

        //// *** IMPERIAL ***

        //// *** MERCENARY - BODYGUARD ***
        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryBodyguard)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatMercenaryBodyGuard() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryBodyguard)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullMercenaryBodyGuard() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryBodyguard)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCMercenaryBodyGuard() { return MercHelpers.MyOOCPS(); }

        //// *** MERCENARY - FIREBUG ***
        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryFirebug)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatMercenaryFirebug() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryFirebug)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullMercenaryFirebug() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryFirebug)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCMercenaryFirebug() { return MercHelpers.MyOOCPS(); }

        //// *** MERCENARY - Arsenal ***
        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryArsenal)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatMercenaryArsenal() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryArsenal)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullMercenaryArsenal() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Mercenary, SkillTreeId.MercenaryArsenal)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCMercenaryArsenal() { return MercHelpers.MyOOCPS(); }

        //// *** POWERTECH - Advanced ***
        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechAdvanced)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatPowertechAdvanced() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechAdvanced)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullPowertechAdvanced() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechAdvanced)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCPowertechAdvanced() { return MercHelpers.MyOOCPS(); }

        //// *** POWERTECH - Firebug ***
        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechFirebug)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatPowertechFirebug() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechFirebug)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullPowertechFirebug() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechFirebug)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCPowertechFirebug() { return MercHelpers.MyOOCPS(); }

        //// *** POWERTECH - ShieldTech ***
        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechShieldTech)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatPowertechShieldTech() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechShieldTech)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullPowertechShieldTech() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.BountyHunter, AdvancedClass.Powertech, SkillTreeId.PowertechShieldTech)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCPowertechShieldTech() { return MercHelpers.MyOOCPS();}

        //// *** Assassin - Darkness ***
        //[Class(CharacterClass.Sorcerer, AdvancedClass.Assassin, SkillTreeId.AssassinDarkness)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatAssassinDarkness() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Sorcerer, AdvancedClass.Assassin, SkillTreeId.AssassinDarkness)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullAssassinDarkness() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Sorcerer, AdvancedClass.Assassin, SkillTreeId.AssassinDarkness)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCAssassinDarkness() { return MercHelpers.MyOOCPS(); }

        //// *** Assassin - Deception ***
        //[Class(CharacterClass.Sorcerer, AdvancedClass.Assassin, SkillTreeId.AssassinDeception)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatAssassinDeception() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Sorcerer, AdvancedClass.Assassin, SkillTreeId.AssassinDeception)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullAssassinDeception() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Sorcerer, AdvancedClass.Assassin, SkillTreeId.AssassinDeception)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCAssassinDeception() { return MercHelpers.MyOOCPS(); }

        //// *** Jugg - Immortal ***
        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautImmortal)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatJuggImmortal() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautImmortal)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullJuggImmortal() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautImmortal)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCJuggImmortal() { return MercHelpers.MyCombatPS(); }

        //// *** Jugg - Rage ***
        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautRage)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatJuggRage() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautRage)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullJuggRage() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautRage)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCJuggRage() { return MercHelpers.MyCombatPS(); }

        //// *** Jugg - Vengeance ***
        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautVengeance)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatJuggVengeance() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautVengeance)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullJuggVengeance() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Juggernaut, SkillTreeId.JuggernautVengeance)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCJuggVengeance() { return MercHelpers.MyOOCPS(); }

        //// *** Marauder - Annihilation ***
        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderAnnihilation)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatMarauderAnnihilation() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderAnnihilation)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullMarauderAnnihilation() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderAnnihilation)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCMarauderAnnihilation() { return MercHelpers.MyOOCPS(); }

        //// *** Marauder - Carnage ***
        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderCarnage)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatMarauderCarnage() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderCarnage)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullMarauderCarnage() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderCarnage)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCMarauderCarnage() { return MercHelpers.MyOOCPS(); }

        //// *** Marauder - Rage ***
        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderRage)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatMarauderCarnage() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderCarnage)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullMarauderCarnage() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.MarauderCarnage)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCMarauderCarnage() { return MercHelpers.MyOOCPS(); }

        //// *** Sorcerer - Corruption ***
        //[Class(CharacterClass.Warrior, AdvancedClass.Sorcerer, SkillTreeId.SorcererCorruption)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatSorcererCorruption() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.SorcererCorruption)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSorcererCorruption() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Warrior, AdvancedClass.Marauder, SkillTreeId.SorcererCorruption)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSorcererCorruption() { return MercHelpers.MyOOCPS(); }

        //// *** Sorcerer - Lightning ***
        //[Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererLightning)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatSorcererLightning() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererLightning)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSorcererLightning() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererLightning)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSorcererLightning() { return MercHelpers.MyOOCPS(); }

        //// *** Sorcerer - Madness ***
        //[Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererMadness)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatSorcererMadness() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererMadness)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSorcererMadness() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Inquisitor, AdvancedClass.Sorcerer, SkillTreeId.SorcererMadness)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSorcererMadness() { return MercHelpers.MyOOCPS(); }


        //// *** REPUBLIC ***

        //// *** SENTINEL - FOCUS ***
        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelFocus)] 
        //[Behavior(BehaviorType.Combat)] 
        //public static Composite JoesCombatSentinelFocus() { return MercHelpers.MyCombatPS();}
        
        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelFocus)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSentinelFocus() { return MercHelpers.MyCombatPS(); }
        
        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelFocus)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSentinelFocus() { return MercHelpers.MyOOCPS(); }

        //// *** SENTINEL - COMBAT ***
        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelCombat)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatSentinelCombat() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelCombat)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSentinelCombat() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelCombat)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSentinelCombat() { return MercHelpers.MyOOCPS(); }

        //// *** SENTINEL - WATCHMAN ***
        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelWatchman)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatSentinelWatchman() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelWatchman)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSentinelWatchman() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Sentinel, SkillTreeId.SentinelWatchman)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSentinelWatchman() { return MercHelpers.MyOOCPS(); }

        //// *** GUARDIAN - DEFENSE ***
        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianDefense)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatGuardianDefense() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianDefense)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullGuardianDefense() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianDefense)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCGuardianDefense() { return MercHelpers.MyOOCPS(); }

        //// *** GUARDIAN - FOCUS ***
        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianFocus)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatGuardianFocus() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianFocus)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullGuardianFocus() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianFocus)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCGuardianFocus() { return MercHelpers.MyOOCPS(); }

        //// *** GUARDIAN - VIGILANCE ***
        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianVigilance)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatGuardianVigilance() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianVigilance)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullGuardianVigilance() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Knight, AdvancedClass.Guardian, SkillTreeId.GuardianVigilance)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCGuardianVigilance() { return MercHelpers.MyOOCPS(); }

        //// *** SAGE - BALANCE ***
        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageBalance)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatSageBalance() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageBalance)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSageBalance() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageBalance)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSageBalance() { return MercHelpers.MyOOCPS(); }

        //// *** SAGE - SEER ***
        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageSeer)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatSageSeer() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageSeer)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSageSeer() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageSeer)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSageSeer() { return MercHelpers.MyOOCPS(); }

        //// *** SAGE - TELEKINETICS ***
        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageTelekinetics)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatSageTelekinetics() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageTelekinetics)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullSageTelekinetics() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Sage, SkillTreeId.SageTelekinetics)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCSageTelekinetics() { return MercHelpers.MyOOCPS(); }

        //// *** COMMANDO - ASSAULT SPECIALIST ***
        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoAssaultSpecialist)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatCommandoAssaultSpecialist() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoAssaultSpecialist)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullCommandoAssaultSpecialist() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoAssaultSpecialist)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCCommandoAssaultSpecialist() { return MercHelpers.MyOOCPS(); }

        //// *** COMMANDO - COMBAT MEDIC ***
        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoCombatMedic)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatCommandoCombatMedic() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoCombatMedic)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullCommandoCombatMedic() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoCombatMedic)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCCommandoCombatMedic() { return MercHelpers.MyOOCPS(); }

        //// *** COMMANDO - GUNNERY ***
        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoGunnery)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatCommandoGunnery() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoGunnery)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullCommandoGunnery() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Commando, SkillTreeId.CommandoGunnery)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCCommandoGunnery() { return MercHelpers.MyOOCPS(); }

        //// *** SHADOW - BALANCE ***
        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowBalance)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatShadowBalance() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowBalance)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullShadowBalance() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowBalance)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCShadowBalance() { return MercHelpers.MyOOCPS(); }

        //// *** SHADOW - Combat ***
        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowCombat]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatShadowCombat() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowCombat)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullShadowCombat() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowCombat)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCShadowCombat() { return MercHelpers.MyOOCPS(); }

        //// *** SHADOW - Infiltration ***
        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowInfiltration]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatShadowInfiltration() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowInfiltration]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullShadowInfiltration() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Consular, AdvancedClass.Shadow, SkillTreeId.ShadowInfiltration]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCShadowInfiltration() { return MercHelpers.MyOOCPS(); }

        //// *** VANGUARD - ASSAULT SPECIALIST ***
        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardAssaultSpecialist)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatVanguardAssaultSpecialist() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardAssaultSpecialist)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullVanguardAssaultSpecialist() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardAssaultSpecialist)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCVanguardAssaultSpecialist() { return MercHelpers.MyOOCPS(); }

        //// *** VANGUARD - SHIELD SPECIALIST ***
        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardShieldSpecialist)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatVanguardShieldSpecialist() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardAssaultSpecialist)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullVanguardShieldSpecialist() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardAssaultSpecialist)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCVanguardShieldSpecialist() { return MercHelpers.MyOOCPS(); }

        //// *** Vanguard - TACTICS  ***
        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardTactics)]
        //[Behavior(BehaviorType.Combat)]
        //public static Composite JoesCombatVanguardTactics() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardTactics)]
        //[Behavior(BehaviorType.Pull)]
        //public static Composite JoesPullVanguardTactics() { return MercHelpers.MyCombatPS(); }

        //[Class(CharacterClass.Commando, AdvancedClass.Vanguard, SkillTreeId.VanguardTactics)]
        //[Behavior(BehaviorType.OutOfCombat)]
        //public static Composite JoesOOCVanguardTactics() { return MercHelpers.MyOOCPS(); }

    }
}
